﻿enyo.kind({
    name: "enyo.ImageButton",
    kind: enyo.CustomButton,
    className: "enyo-button",
    published: {
        icon: "",
        /**
        If false then the icon property specifies an image file path; if true, it is a css className.
        */
        iconIsClassName: false
    },
    components: [
		{ name: "icon", className: "enyo-button-icon" },
	],
    //* @protected
    create: function () {
        this.inherited(arguments);
        this.iconChanged();
    },
    iconChanged: function (inOldValue) {
        if (this.iconIsClassName) {
            this.applyIconClassName(inOldValue);
        } else {
            this.applyIconImage(inOldValue);
        }
    },
    applyIconImage: function () {
        this.$.icon.applyStyle("background-image", "url(" + enyo.path.rewrite(this.icon) + ")");
        this.$.icon.applyStyle("background-repeat", "no-repeat");
        this.$.icon.applyStyle("background-position", "center center");
    },
    applyIconClassName: function (inOldValue) {
        console.log('class applied');
        if (inOldValue) {
            this.$.icon.removeClass(inOldValue);
        }
        this.$.icon.addClass(this.icon);
    },
});