enyo.kind({
    name: "Vksource",
    kind: enyo.HFlexBox,
    components: [
        { kind: "Pane", flex: 1, transitionKind: "enyo.transitions.Simple", components: [
            { kind: enyo.VFlexBox, components: [
		        { name: "slidingPane", kind: "SlidingPane", flex: 1, components: [
			        { name: "left", components: [
		                { kind: enyo.VFlexBox, flex: 1, style: "border-right: 2px solid;", components: [
			                { kind: "PageHeader", components: [
                                { kind: "SearchInput", name: "tbSearch", flex: 1, onkeypress: "onEnterSearch" }
			                ]
			                },
			                { flex: 1, kind: "Pane", components: [
					                { name: "list", kind: "VirtualList", flex: 1, onSetupRow: "listSetupRow", components: [
						                { kind: "Item", layoutKind: "HFlexLayout", align: "center", onclick: "itemClick",
						                    components: [
                                                { name: "trackSlider", kind: enyo.VFlexBox, flex: 1, align: "left", components: [
							                        { name: "name", style: "padding-left: 10px;" },
                                                    { kind: "ProgressSlider", showing: false, lockBar: false,
                                                        style: "padding-left:10px;padding-right:10px;padding-top:5px",
                                                        onChange: "positionChange"
                                                    },
                                                ]
                                                },

                                                { name: "itemLength", style: "padding-left: 5px;padding-right: 10px; font-size:10pt;" },
                                                { name: "btnPlay", kind: "Image", src: "images/play.png",
                                                    style: "padding-right: 10px;",
                                                    width: "28px", height: "28px", onclick: "onPlayClick"
                                                },
                                                { name: "btnDown", kind: "Image", src: "images/download.png",
                                                    width: "28px", height: "28px", onclick: "onDownClick"
                                                },
		                                        { name: "downloadProgress", kind: "ProgressButton",
		                                            showing: false, flex: 1, animatePosition: false,
		                                            position: 0, onCancel: "onCancelDownloadClick", components: [
			                                        { kind: "HFlexBox", components: [
				                                        { content: "", name: "dpTitle" },
				                                        { kind: "Spacer" },
				                                        { content: "", name: "dpValue" }
			                                        ]
			                                        }
		                                        ]
		                                        }
						                ]
						                },
					                ]
					                },
                                ]
			                },
			                { kind: "Toolbar", className: "enyo-toolbar-light", align: "center", components: [
                                { name: "btnRepeat", kind: "Image", src: "images/repeat.png", style: "padding-left: 10px; vertical-align:middle;",
                                    width: "36px", height: "25px", onclick: "onRepeatClick"
                                },
                                { name: "btnShuffle", kind: "Image", src: "images/shuffle.png", style: "padding-left: 10px; vertical-align:middle;",
                                    width: "36px", height: "25px", onclick: "onShuffleClick"
                                },
                                { content: "", flex: 1 },
                                { content: "", name: "count" },
                                { kind: "Button", caption: "prev", showing: false },
                                { kind: "Button", caption: "next", showing: false }
			                ]
			                }
		                ]
		                }
                    ]
			        },
			        { name: "right", fixedWidth: true, onResize: "slidingResize", components: [
		                { kind: enyo.VFlexBox, flex: 1, components: [
			                { kind: "PageHeader", components: [
				                { content: "Lyrics" }
			                ]
			                },
			                { flex: 1, kind: "Pane", width: "600px", components: [
				                { flex: 1, kind: "Scroller", components: [
                                    { tag: "p", name: "web", allowHtml: true, style: "padding-left: 5px" }
				                ]
				                }
			                ]
			                },
			                { kind: "Toolbar", align: "left", pack: "left", components: [
                                { kind: "GrabButton", slidingHandler: true, onclick: "slideChanged" },
                                { caption: "", name: "stitle", flex: 1, style: "color: white; text-align: left;" },
			                ]
			                }
		                ]
		                },
                    ]
			        }
                ]
		        }
            ]
            }
        ]
        },

        { kind: "AppMenu", components: [
                { caption: "About", onclick: "onMenuAbout" },
                { caption: "Exit", onclick: "onMenuExit" }
            ]
        },

        { kind: "Popup", name: "pNewName", components: [
          { content: "Please rename filename" },
          { kind: "Input", name: "pfilename" },
          { kind: "Button", caption: "Ok", onclick: "closePopup" },
          { kind: "Button", caption: "Cancel", onclick: "cancelPopup" }
        ]
        },
        { kind: "Popup", name: "pMessage",
            lazy: false,
            components: [
              { kind: "Group", caption: " ", components: [
                { content: "", name: "popupMessage", style: "padding-left:10px;padding-right:10px;padding-top:10px;" },
                { nodeTag: "br" },
                { kind: "Button", caption: "Ok", onclick: "closePopupMessage" },
              ]
              },
        ]
        },

        { name: "aboutDialog", kind: "ModalDialog", caption: $L("About"), width: "400px", components: [
		    { kind: "HFlexBox", components: [
	            { components: [
		            { kind: "Image", src: 'images/vkontakte_note.png', style: "padding-left: 20px; margin-right: 10px" }
			    ]
	            },
			    { style: "padding-left: 10px;", components: [
			        { content: $L("Vkontakte Music Downloader"), className: 'enyo-text-subheader enyo-text-ellipsis' },
	                { content: $L("Version " + enyo.fetchAppInfo().version), className: 'enyo-text-ellipsis enyo-subtext' }
			    ]
			    }
	        ]
		    },
            { layoutKind: "HFlexLayout", pack: "center", components: [
                { kind: "Button", caption: "OK", width: "120px", onclick: "aboutClose" },
            ]
            }
        ]
        },

        appId = 2998689,
        { name: "auth", kind: "WebService",
            url: "http://oauth.vk.com/authorize?client_id=" + this.appId + "&scope=audio,video&redirect_uri=http://oauth.vk.com/blank.html&display=popup&response_type=token",
            onSuccess: "onAuthSuccess",
            onFailure: "onAuthFailure"
        },
        { name: "grant", kind: "WebService",
            url: "http://oauth.vk.com/grant_access?hash={0}&client_id=" + this.appId + "&settings=24&redirect_uri=blank.html&response_type=token&state=&token_type=0",
            onSuccess: "onGrantSuccess",
            onFailure: "onGrantFailure"
        },

        { name: "method", kind: "WebService",
            url: "https://api.vk.com/method/",
            onSuccess: "onMethodSuccess",
            onFailure: "onMethodFailure"
        },
        { name: "lyrics", kind: "WebService",
            url: "https://api.vk.com/method/audio.getLyrics",
            onSuccess: "onLyricsSuccess"
        },

        { name: "login", kind: "WebService",
            url: "https://login.vk.com/?act=login&to=&from_host=m.vk.com&from_protocol=http&pda=1",
            method: "POST",
            headers: { "Cookie": "" },
            onSuccess: "onLoginSuccess",
            onFailure: "onLoginFailure"
        },

        { kind: "Sound", preload: false },

        { name: "servStartDownload",
            kind: "PalmService",
            service: "palm://com.palm.downloadmanager/",
            method: "download",
            onSuccess: "downloadFinished",
            onFailure: "downloadFail",
            onResponse: "gotResponse",
            subscribe: true
        },
        { name: "servCancelDownload",
            kind: "PalmService",
            service: "palm://com.palm.downloadmanager/",
            method: "cancelDownload",
            onSuccess: "cancelDownloadFinished",
            onFailure: "cancelDownloadFail",
            onResponse: "gotResponse"
        },

        { name: "connStatus", kind: "PalmService", service: "palm://com.palm.connectionmanager/",
            method: "getStatus", onSuccess: "statusFinished", onFailure: "statusFail"
        }
    ],

    // ======================== Internet Connection ========================

    isOnline: false,
    statusFinished: function (inSender, inResponse) {
        enyo.log("conn inet status: " + inResponse.isInternetConnectionAvailable);
        if (inResponse.isInternetConnectionAvailable) {
            this.isOnline = true;
            this.onSearch(this, null);
        }
        else {
            this.resetLocks();
            this.$.popupMessage.setContent("No internet connection is found");
            this.$.pMessage.openAtCenter();
        }
    },
    statusFail: function (inSender, inResponse) {
        console.log("conn failed");
    },

    // =====================================================================

    rendered: function () {
        this.inherited(arguments);
        this.adjustSlidingSize();
    },
    resizeHandler: function () {
        this.adjustSlidingSize();
        var v = this.$.pane.view;
        if (v && v.resizeHandler) {
            v.resizeHandler();
        }
    },
    adjustSlidingSize: function () {
        var s = enyo.fetchControlSize(this);
        var pcs = enyo.fetchControlSize(this.$.right.$.client);
        this.$.left.node.style.width = (s.w - 60) + "px";
        this.$.right.setPeekWidth(s.w - pcs.w);
    },
    slidingResize: function (inSender, inEvent) {
        var s = enyo.fetchControlSize(this);
        var pcs = enyo.fetchControlSize(this.$.right.$.client);
        this.$.left.node.style.width = (s.w - pcs.w) + "px";
    },

    expanded: true,
    slideChanged: function (inSender, inEvent) {

        this.expanded = !this.expanded;
        var s = enyo.fetchControlSize(this);
        var pcs = enyo.fetchControlSize(this.$.right.$.client);

        if (this.expanded)
            this.$.left.node.style.width = (s.w - 60) + "px";
        else
            this.$.left.node.style.width = (s.w - pcs.w) + "px";

        this.$.list.refresh();
    },

    token: "", // access token
    authcookie: "", // remixsid
    granthash: "",

    onEnterSearch: function (inSource, inEvent) {
        if (inEvent.keyCode == 13) {

            // recheck internet connection status
            this.isOnline = false;
            this.onSearch(this, null);
        }
    },

    onSearch: function (inSource, inEvent) {
        enyo.scrim.show();

        if (!this.isOnline) {
            this.$.connStatus.call();
            return;
        }

        // receive token if empty
        if (this.token == "" && !this.searching) {
            this.searching = true;
            this.$.login.call({ email: "contaktovitch@yandex.ru", pass: "qylBJ7VXYl" });
        }
        else {
            this.runSearch();
        }
    },

    runSearch: function () {
        if (!this.token) {
            console.log("search failed: token is empty.");
            this.resetLocks();
            return;
        }

        if (this.$.tbSearch.getValue() == "") {
            console.log("search failed: search query is empty.");
            this.resetLocks();
            return;
        }

        this.$.method.setUrl("https://api.vk.com/method/audio.search?q=" + this.$.tbSearch.getValue() + "&count=100&access_token=" + this.token);
        this.$.method.call();
    },

    onAuthSuccess: function (inSender, inResponse, inRequest) {
        console.log('auth success');
        console.log(enyo.json.stringify(inResponse));

        try {
            this.granthash = inResponse.split('grant_access?hash=')[1];
            this.granthash = this.granthash.split('&')[0];
        }
        catch (err) {
            console.log('granthash err: ' + err);
        }

        // check if access granted already
        this.location = inRequest.xhr.getResponseHeader("Location");
        if (this.location && this.parseToken(this.location)) {
            if (this.searching)
                this.runSearch();
        }
        else {

            // not granted, request it
            console.log("hash: " + this.granthash);

            if (this.granthash) {
                this.$.grant.headers = { "Cookie": "remixsid=" + this.authcookie };
                this.$.grant.setUrl("http://oauth.vk.com/grant_access?hash=" + this.granthash + "&client_id=" + this.appId + "&settings=24&redirect_uri=blank.html&response_type=token&state=&token_type=0"),
                this.$.grant.call();
            }
        }
    },
    onAuthFailure: function (inSender, inResponse, inRequest) {
        console.log('auth failed');
        console.log(enyo.json.stringify(inResponse));

        this.resetLocks();
    },

    onMethodSuccess: function (inSender, inResponse, inRequest) {
        this.resetLocks();
        console.log('method success');
        console.log("len: " + inResponse.response.length);
        //this.$.web.setContent(enyo.json.stringify(inResponse.response));

        this.$.count.setCaption("found: " + inResponse.response[0]);
        inResponse.response.shift();

        this.stopPlaying();
        this.foundItems = inResponse.response;
        this.$.list.refresh();
    },
    onMethodFailure: function (inSender, inResponse, inRequest) {
        this.resetLocks();
        console.log('method failed');
        console.log(enyo.json.stringify(inResponse));
    },

    resetLocks: function () {
        if (this.searching) {
            this.searching = false;
        }
        enyo.scrim.hide();
    },

    onLoginSuccess: function (inSender, inResponse, inRequest) {
        console.log('login success');

        this.cookies = inRequest.xhr.getResponseHeader("Set-Cookie");
        console.log('cookie: ' + this.cookies);
        try {
            this.authcookie = this.cookies.split('remixsid=')[1];
            this.authcookie = this.authcookie.split(';')[0];
            this.authcookie = this.authcookie.split(',')[0];
        }
        catch (err) {
            console.log('remixsid err: ' + err);
        }

        if (this.authcookie) {
            this.$.auth.headers = { "Cookie": "remixsid=" + this.authcookie };
            this.$.auth.call();
        }
        else {
            this.resetLocks();
            this.$.popupMessage.setContent("Can't get authorization cookie");
            this.$.pMessage.openAtCenter();
        }

        console.log('remixsid: ' + this.authcookie);
    },
    onLoginFailure: function (inSender, inResponse, inRequest) {
        console.log('login failed');
        console.log(enyo.json.stringify(inResponse));

        this.resetLocks();
    },

    onGrantSuccess: function (inSender, inResponse, inRequest) {
        console.log('grant success');
        this.location = inRequest.xhr.getResponseHeader("Location");
        if (this.location && this.parseToken(this.location)) {
            if (this.searching)
                this.runSearch();
        }
        else {
            this.resetLocks();
            this.$.popupMessage.setContent("Can't get access hash");
            this.$.pMessage.openAtCenter();
        }
    },
    onGrantFailure: function (inSender, inResponse, inRequest) {
        this.resetLocks();
        console.log('grant failed');
        console.log(enyo.json.stringify(inResponse));
    },

    onLyricsSuccess: function (inSender, inResponse, inRequest) {
        console.log('lyrics success');
        if (inResponse.response)
            this.$.web.setContent(inResponse.response.text.replace(/\n/g, "<br/>"));
    },

    parseToken: function (location) {
        if (!location) return false;

        try {

            this.token = location.split('access_token=')[1];
            this.token = this.token.split('&')[0];

            return true;
        }
        catch (e) {
            console.log('parseToken failed: ' + location);
        }

        if (this.token) return true;
        return false;
    },

    foundItems: [],
    playRowIndex: "",
    downloadRowIndex: "",
    playing: false,
    paused: false,
    repeat: false,
    shuffle: false,
    refreshLock: false,
    listSetupRow: function (inSender, inRow) {

        var c = this.foundItems && this.foundItems[inRow];
        if (c) {

            var songName = c.artist.substr(0, 20) + ' - ' + c.title.substr(0, 50)
            if (this.expanded)
                songName = c.artist.substr(0, 50) + ' - ' + c.title.substr(0, 100)

            var songLen = this.formatDuration(c.duration);
            var songLength = '[' + songLen + ']';

            // if downloading in progress
            if (this.downloading && inRow == this.downloadRowIndex) {
                this.$.trackSlider.setShowing(false);
                this.$.itemLength.setShowing(false);
                this.$.btnPlay.setShowing(false);
                this.$.btnDown.setShowing(false);
                this.$.downloadProgress.setShowing(true);

                var trimSongName = songName;

                if (songName.length > 20)
                    trimSongName = songName.substr(0, 25) + "..";

                if (this.expanded)
                    if (songName.length > 50)
                        trimSongName = songName.substr(0, 80) + "..";

                this.$.dpTitle.setContent(trimSongName);
                this.$.dpValue.setContent(this.downloadProgressValue);
                if (this.$.downloadProgress.getMaximum() != this.downloadLength)
                    this.$.downloadProgress.setMaximum(this.downloadLength);
                this.$.downloadProgress.setPositionImmediate(this.downloadPosition);
                this.updatingList = false;
            }
            else {
                this.$.trackSlider.setShowing(true);
                this.$.itemLength.setShowing(true);
                this.$.btnPlay.setShowing(true);
                this.$.btnDown.setShowing(true);
                this.$.downloadProgress.setShowing(false);

                this.$.name.setContent(songName);
                this.$.itemLength.setContent(songLength);

                if (this.playing && inRow == this.playRowIndex) {
                    this.$.item.addClass("enyo-button-light");
                    if (this.paused)
                        this.$.btnPlay.setSrc("images/play.png");
                    else
                        this.$.btnPlay.setSrc("images/pause.png");

                    // update playing position time
                    var currPos = this.formatDuration(this.$.sound.audio.currentTime);
                    this.$.itemLength.setContent('[' + currPos + '/' + songLen + ']');
                    this.$.progressSlider.setMaximum(c.duration);
                    this.$.progressSlider.setPosition(this.$.sound.audio.currentTime);

                    // show buffering progress
                    if (this.$.sound.audio.buffered != 'undefined' && this.$.sound.audio.buffered.length != 0) {
                        this.$.progressSlider.setBarMaximum(c.duration);
                        this.$.progressSlider.setAltBarPosition(this.$.sound.audio.buffered.end(0));
                    }

                    this.$.progressSlider.setShowing(true);

                    if (!this.refreshLock) {
                        this.refreshLock = true;
                        // there is no reason to set less timeout
                        // cause audio progress bar step one second
                        window.setTimeout(enyo.hitch(this, function () {
                            this.refreshLock = false;
                            this.$.list.updateRow(this.playRowIndex);
                        }), 1000);
                    }
                }
                else {
                    this.$.item.removeClass("enyo-button-light");
                    this.$.btnPlay.setSrc("images/play.png");
                    this.$.progressSlider.setShowing(false);
                }
            }
            return true;
        }
    },
    formatDuration: function (duration) {
        duration = parseInt(duration);
        var min = (duration / 60) << 0;
        var sec = (duration) % 60;

        if (sec < 10) {
            if (sec == 0)
                sec = '00'
            else
                sec = '0' + sec;
        }

        return min + ':' + sec;
    },

    itemClick: function (inSender, inEvent) {
        //var c = this.foundItems[inEvent.rowIndex];
    },
    onPlayClick: function (inSender, inEvent) {
        var c = this.foundItems[inEvent.rowIndex];
        if (this.playing && inEvent.rowIndex == this.playRowIndex) {

            // HTML5 audio control
            if (this.paused)
                this.$.sound.audio.play();
            else
                this.$.sound.audio.pause();

            this.paused = !this.paused;
        }
        else {
            console.log('start play');
            this.$.sound.setSrc(c.url);
            this.$.sound.play();

            // add listener on stop playing event
            // start next playing if option turned on
            this.$.sound.audio.addEventListener(
                'ended', enyo.hitch(this, function () {
                    console.log('sound ended fired');

                    if (!this.foundItems) return;

                    // check for next item
                    var nxtIndex = this.playRowIndex + 1;
                    var rndIndex = Math.floor((Math.random() * this.foundItems.length) + 1);

                    if (this.shuffle && this.foundItems[rndIndex]) {
                        console.log('play shuffle next');
                        var e = new Object();
                        e.rowIndex = rndIndex;
                        this.onPlayClick(this, e);
                    }
                    else if (this.repeat) {
                        if (!this.foundItems[nxtIndex]) {
                            nxtIndex = 0;
                            if (!this.foundItems[nxtIndex]) {
                                console.log('stop playing, next item failed');
                                return;
                            }
                        }

                        // if found - play next
                        console.log('play repeat next');
                        var e = new Object();
                        e.rowIndex = nxtIndex
                        this.onPlayClick(this, e);
                    }
                    else {
                        // end of the list - turn off
                        console.log('stop playing');
                        this.stopPlaying();
                    }
                }), false);

            if (c.lyrics_id) {
                this.$.lyrics.setUrl("https://api.vk.com/method/audio.getLyrics?lyrics_id=" + c.lyrics_id + "&access_token=" + this.token);
                this.$.lyrics.call();
            }
            else {
                this.$.web.setContent("no lyrics");
            }
            this.playRowIndex = inEvent.rowIndex;

            this.paused = false;
            this.playing = true;
            this.$.stitle.setCaption(c.artist.substr(0, 20) + ' - ' + c.title.substr(0, 50));
        }

        this.$.list.refresh();
        //this.scrollToPlaying();
    },

    scrollToPlaying: function () {

        //scrolls to a specific index in the list
        //assumes all items are the same height--might not be perfect assumption

        var scr = this.$.list.$.scroller;
        var scrollSpot = 0;
        for (var h in scr.heights) {

            //scr.heights is an array of the heights of items in the list, but only
            //contains entries for the visible items--so if list has been scrolled down,
            //it will contain lots of empty cells at the beginning

            if (h) {
                scrollSpot = scr.heights[h] * this.playRowIndex;
                break;
                //gets the first height in the list
            }
        }
        scr.$.scroll.setScrollPosition(-scrollSpot);
        scr.start();
    },

    stopPlaying: function () {
        this.$.sound.audio.pause();
        this.playing = false;
        this.paused = false;
        this.playRowIndex = null;
        this.$.stitle.setCaption("");
        this.$.web.setContent("");
        this.$.list.refresh();
    },
    onRepeatClick: function (inSender, inEvent) {
        this.repeat = !this.repeat;
        if (this.repeat)
            this.$.btnRepeat.setSrc("images/repeat_selected.png");
        else
            this.$.btnRepeat.setSrc("images/repeat.png");
    },
    onShuffleClick: function (inSender, inEvent) {
        this.shuffle = !this.shuffle;
        if (this.shuffle)
            this.$.btnShuffle.setSrc("images/shuffle_selected.png");
        else
            this.$.btnShuffle.setSrc("images/shuffle.png");
    },

    positionChange: function (inSender, inEvent) {
        this.$.sound.audio.currentTime = inSender.getPosition();
    },

    // ========================== Downloading =======================================

    onDownClick: function (inSender, inEvent) {
        var c = this.foundItems[inEvent.rowIndex];
        this.url = c.url;
        this.filename = c.artist.substr(0, 20).replace(/\\/g, '').replace(/"/g, ' ') + ' - ' +
                        c.title.substr(0, 50).replace(/\\/g, '').replace(/"/g, ' ') + ".mp3";
        console.log($L('filename: ' + this.filename));

        this.runDownloader(inEvent.rowIndex);
    },
    onCancelDownloadClick: function (inSender, inEvent) {
        console.log('download cancel clicked');
        if (this.downloading && !this.downloadCanceling) {
            this.downloadCanceling = true;
            this.$.servCancelDownload.call({ ticket: this.downloadTicket });
        }
    },

    runDownloader: function (index) {
        if (!this.downloading) {

            if (index == 'undefined' || index < 0) {
                console.log("runDownloader failed: index param is empty");
                return;
            }
            this.downloading = true;
            this.downloadRowIndex = index;
            console.log("start download: " + index);
            this.showDownloadProgress();

            this.$.servStartDownload.call({
                target: this.url,
                mime: "audio/mp3",
                targetDir: "/media/internal/audio/",
                targetFilename: $L(this.filename),
                keepFilenameOnRedirect: false,
                canHandlePause: true,
                subscribe: true
            });
        }
    },

    downloadPosition: 0,
    downloadLength: 100,
    downloadProgressValue: "",
    downloadTicket: -1,
    lastDownloadIndex: "",
    downloading: false,
    downloadCanceling: false,
    filename: "",
    url: "",
    downloadFinished: function (inSender, inResponse) {
        if (inResponse.errorCode) {
            enyo.windows.addBannerMessage("Download failed");
            this.downloading = false;
            this.hideDownloadProgress();
        }
        if (inResponse.returnValue) {
            this.downloadTicket = inResponse.ticket;
            enyo.windows.addBannerMessage("Download started: " + this.filename, "{}", "{}", "notification");
        }
        if (inResponse.completed) {
            enyo.windows.addBannerMessage("Download completed: " + this.filename, "{}", "{}", "notification");
            this.downloading = false;
            this.hideDownloadProgress();
        }
        if (inResponse.amountReceived) {
            this.updateDownloadProgress(inResponse.amountReceived, inResponse.amountTotal);
        }
        enyo.log("Download success, results=" + enyo.json.stringify(inResponse));
    },
    downloadFail: function (inSender, inResponse) {
        enyo.windows.addBannerMessage("Download failed", "{}", "{}", "notification");
        this.downloading = false;
        this.hideDownloadProgress();
        enyo.log("Download failure, results=" + enyo.json.stringify(inResponse));

        this.$.pNewName.openAtCenter();
        this.$.pfilename.setValue(this.filename);
    },

    cancelDownloadFinished: function (inSender, inResponse) {
        this.hideDownloadProgress();
        enyo.log("Cancel Download success, results=" + enyo.json.stringify(inResponse));
        enyo.windows.addBannerMessage("Download canceled: " + this.filename, "{}", "{}", "notification");
        this.downloading = false;
        this.downloadCanceling = false;
    },
    cancelDownloadFail: function (inSender, inResponse) {
        this.downloadCanceling = false;
        enyo.log("Cancel Download failure, results=" + enyo.json.stringify(inResponse));
    },

    showDownloadProgress: function () {
        this.downloadProgressValue = "";
        this.$.list.refresh();
    },
    updatingList: false,
    updateDownloadProgress: function (received, total) {

        var divider = 1;
        var unit = "Kb";
        if (total > 1000000) { // in Mb
            divider = 1000000;
            unit = "Mb";
        }
        else if (total > 1000) { // in Kb
            divider = 1000;
            unit = "Kb";
        }

        var sreceived = (received / divider).toFixed(2);
        var stotal = (total / divider).toFixed(2);
        this.downloadProgressValue = "" + sreceived + "/" + stotal + " " + unit;

        this.downloadPosition = received;
        this.downloadLength = total;

        if (!this.updatingList) {
            this.updatingList = true;
            this.$.list.updateRow(this.downloadRowIndex);
        }
    },
    hideDownloadProgress: function () {
        this.lastDownloadIndex = this.downloadRowIndex;
        this.downloadRowIndex = null;
        this.$.list.refresh();
    },

    // ======================= Popup =============================

    closePopup: function (inSender, inEvent) {
        this.$.pNewName.close();
        this.filename = this.$.pfilename.getValue();
        this.runDownloader(this.lastDownloadIndex);
    },
    cancelPopup: function (inSender, inEvent) {
        this.$.pNewName.close();
    },
    aboutClose: function (inSender, inEvent) {
        this.$.aboutDialog.close();
    },

    closePopupMessage: function (inSender, inEvent) {
        this.$.pMessage.close();
    },
    // ======================== Menu ==============================

    onMenuAbout: function () {
        this.$.aboutDialog.openAtCenter();
    },
    onMenuExit: function () {
        window.close();
    }

});
